cordova.define("cordova-plugin-myuptodate.myuptodate", function(require, exports, module) {
var exec = require('cordova/exec'),
    DirectoryEntry = require('cordova-plugin-file.DirectoryEntry'),
    FileEntry = require('cordova-plugin-file.FileEntry'),
    fileSystems = require('cordova-plugin-file.fileSystems');

var myuptodate = {
    getAvailableStorage: function (successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'MyUpToDate', 'getAvailableStorage', []);
    },

    getFreeSpace: function (path, successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'MyUpToDate', 'getFreeSpace', [path]);
    },

    chooseFileAndUnzip: function (path, successCallback, errorCallback, progressCallback) {
        var successCallbackWrapper = function (result) {
            if (result && typeof result.loaded != 'undefined')
                progressCallback(result);
            else
                successCallback(result);
        };

        exec(successCallbackWrapper, errorCallback, 'MyUpToDate', 'chooseFileAndUnzip', [path]);
    },

    download: function (source, target, bookId, fileSize, successCallback, errorCallback, progressCallback) {
        var successCallbackWrapper = function (result) {
            if (result && typeof result.loaded != 'undefined')
                progressCallback(result);
            else
                successCallback();
        };

        exec(successCallbackWrapper, errorCallback, 'MyUpToDate', 'download', [source, target, bookId, fileSize]);
    },

    abort: function (bookId, successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'MyUpToDate', 'abort', [bookId]);
    },

    saveHtmlAsPdf: function (html, filePath, successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'HtmlToPdf', 'create', [html, filePath])
    },

    openDirectoryInFileManager: function (directory, successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'MyUpToDate', 'openDirectoryInFileManager', [directory])
    }
};

module.exports = myuptodate;

});
